﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using System.IO;
using System.Windows;
using System.Threading;

using System.Data;
using System.Collections.ObjectModel;
using DB_ABT.DBS_Klassen;
using DB_ABT.ViewModels;
using DB_ABT.Models;

namespace DB_ABT.DBS_Klassen {
    public class Dbs_QueriesExceute {

        public static String SQL_getAbteilungen() {
            return "SELECT Pindex, shortname, longname FROM " + "Department" + " ORDER BY shortname;";
        }

        public static ObservableCollection_Dept getItemsFromDept() {
            ObservableCollection_Dept abt_class = new ObservableCollection_Dept();
            ObservableCollection<ModelDept> abtitems = abt_class.Items;
            String sql = SQL_getAbteilungen();
            Dbs dbs = Dbs.getDbsInstance();
            DataTable dt = dbs.selectDBS(sql);
            ModelDept dept=null;
            foreach (System.Data.DataRow row in dt.Rows) {
                dept = new ModelDept();
                dept.PIndex = (int)row.ItemArray[0];
                dept.ShortName = (String)row.ItemArray[1];
                dept.LongName = (String)row.ItemArray[2];
                dept.newAttrib = false;
                dept.modifyAttrib = false;
                abtitems.Add(dept);
            }
            return abt_class;
        }  // ObservableCollection_Abt


        public static ObservableCollection<ModelDept> getListFromAbt() {
            ObservableCollection<ModelDept> liste = new ObservableCollection<ModelDept>();
            String sql = SQL_getAbteilungen();
            Dbs dbs = Dbs.getDbsInstance();
            DataTable dt = dbs.selectDBS(sql);
            ModelDept dept = null;
            foreach (System.Data.DataRow row in dt.Rows) {
                dept = new ModelDept();
                dept.PIndex = (int)row.ItemArray[0];
                dept.ShortName = (String)row.ItemArray[1];
                dept.LongName = (String)row.ItemArray[2];
                dept.newAttrib = false;
                dept.modifyAttrib = false;
                liste.Add(dept);
            }
            return liste;
        }  // getListFromAbt


        public static String SQL_getMitarbeiter() {
            return "SELECT firstname, lastname, monthsalary, Pindex, deptindex FROM " + "Employee" + " ORDER BY lastname, firstname;";
        }


        public static ObservableCollection_Employee getItemsFromMitarbeiter() {
            ObservableCollection_Employee mit_class = new ObservableCollection_Employee();
            ObservableCollection<ModelEmployee> mititems = mit_class.Items;
            String sql = SQL_getMitarbeiter();
            Dbs dbs = Dbs.getDbsInstance();
            DataTable dt = dbs.selectDBS(sql);
            ModelEmployee empl = null;
            foreach (System.Data.DataRow row in dt.Rows) {
                empl = new ModelEmployee();
                empl.Firstname = (String)row.ItemArray[0];
                empl.Lastname = (String)row.ItemArray[1];
                empl.Monthsalary = (double)row.ItemArray[2];
                empl.PIndex = (int)row.ItemArray[3];
                empl.DeptIindex = (int)row.ItemArray[4];
                empl.newAttrib = false;
                empl.modifyAttrib = false;
                mititems.Add(empl);
            }
            return mit_class;
        }


        public static DataTable getDataTableFromMitarbeiter() {
            String sql = SQL_getMitarbeiter();
            Dbs dbs = Dbs.getDbsInstance();
            return  dbs.selectDBS(sql);
        }

        public static String SQL_getAbteilungenFromMitarbeiter() {
            return "SELECT DISTINCT DeptIndex FROM Employee;";
        }

        public static bool isForeignKeyInMitarbeiter(long aindex) {
            String sql = SQL_getAbteilungenFromMitarbeiter();
            Dbs dbs = Dbs.getDbsInstance();
            DataTable dt = dbs.selectDBS(sql);            
            bool gefunden=false;
            foreach (System.Data.DataRow row in dt.Rows) {
                long ai = (int)row.ItemArray[0];
                if (ai == aindex) {
                    gefunden = true;
                    break;
                }
            }
            return gefunden;
        }


    }
}
