﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;


using System.IO;
using System.Threading;
using System.Windows.Threading;
using DB_ABT.DBS_Klassen;

namespace DB_ABT.Fenster {
    /// <summary>
    /// Interaktionslogik für FProgressBarCreateTables.xaml
    /// </summary>
    public partial class FProgressBarCreateTables : Window {

        Thread t = null;
        String[] sql_commands;
        Dbs dbs = Dbs.getDbsInstance();
        private String sqlfilename;


        public FProgressBarCreateTables(Window parent, String sqlfilename) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner      
            this.WindowStartupLocation = System.Windows.WindowStartupLocation.CenterOwner;
            this.sqlfilename = sqlfilename;

        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            labelTitel.Content = "Eintragen der SQL-Befehle in die Datenbank";
            String sSQL = File.ReadAllText(Basis.getProgPath() + sqlfilename);
            sql_commands = sSQL.Split(new Char[] { ';' });
            progressbar.Maximum = sql_commands.Length;
            progressbar.Minimum = 0;

            t = new Thread(insertTables);
            t.Start();
            DispatcherTimer dispatcherTimer = new DispatcherTimer();
            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(250);   // new TimeSpan(0, 0, 1); // hour, min, sec
            dispatcherTimer.Start();
        }

        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            if (t.ThreadState == ThreadState.Stopped) Close();
            CommandManager.InvalidateRequerySuggested();
        }

        public void insertTables2() {
            const int SQL_ANZ = 2;
            int i = 0;
            int anzSQL = 0;
            StringBuilder sb = new StringBuilder(10000);
            sb.Append("execute block as begin\r\n");
            foreach (String sql in sql_commands) {
                i++;
                setValue(i);
                // Thread.Sleep(20);
                if (sql.Trim().Length > 0) {
                    anzSQL++;
                    if (anzSQL > SQL_ANZ) {
                        sb.Append("end\r\n");
                        dbs.changeDBS(sb.ToString());
                        sb.Clear();
                        sb.Append("execute block as begin\r\n");
                        anzSQL = 0;
                    }
                    sb.Append(sql);
                    sb.AppendLine(";");
                }
            } // foreach
            if (anzSQL > 0) {
                sb.Append("end\r\n");
                dbs.changeDBS(sb.ToString());
            }
            Basis.Message("Die Datenbank wurde erzeugt", "Hinweis");
        }

        public void insertTables() {
            int i = 0;
            foreach (String sql in sql_commands) {
                i++;
                setValue(i);
                // Thread.Sleep(20);
                if (sql.Trim().Length > 0) {
                    dbs.selectDBS(sql);
                    // File.WriteAllText(Basis.getProgPath() + "gelog_2015.erg", sql);
                }
            }
            Basis.Message("Die Datenbank wurde erzeugt", "Hinweis");
        }

        public void setValue(int value) {
            UpdateProgressBar(value);
        }


        private void UpdateProgressBar(int i) {
            // Action is delegate (means a function pointer) which is Pointing towards "SetProgress" method
            Action action = () => { SetProgress(i); };

            // Here Dispacthers Invoke (is a Syncronus)/ BegineInvoke (Is Asyncornus) in Called 
            progressbar.Dispatcher.BeginInvoke(action);
        }

        private void SetProgress(int value) {
            labelProgress.Content = "Verlauf: " + (value * 100.0 / progressbar.Maximum).ToString("0.0") + " %";
            progressbar.Value = value;
        }



        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            if (t.IsAlive) t.Abort();
        }

    }
}
