﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using System.ComponentModel;
using DB_ABT.Models;

namespace DB_ABT.Models {
    public class ModelDept : ModelBase {   

        private String shortName;
        private String longName;
        private long pindex;

        public ModelDept():this(-1,"","") {
        }

        public ModelDept(long pindex, String kurzBez, String bez) {
            PIndex = pindex;
            ShortName = kurzBez;
            LongName = bez;
        }

        public ModelDept(ModelDept dept) {
            PIndex = dept.pindex;
            ShortName = dept.shortName;
            LongName = dept.longName;
        }

        public override int CompareTo(object obj) {
            ModelDept abt = (ModelDept)obj;
            return shortName.CompareTo(abt.shortName);
        }

        public String getKurzBezQuote() {
            return "'" + shortName + "'";
        }
        public String getBezQuote() {
            return "'" + longName + "'";
        }

        
        public String ShortName {
            get { return shortName; }
            set {
                if (value != shortName) {
                    NotifyPropertyChanged("ShortName");                    
                    modifyAttrib = true;
                    shortName = value;
                    System.Diagnostics.Debug.WriteLine("Change ShortName: " + shortName);
                }
            }
        }

       


        public String LongName {
            get { return longName; }
            set {
                if (value != longName) {
                    NotifyPropertyChanged("LongName");
                    modifyAttrib = true;
                    longName = value;
                    System.Diagnostics.Debug.WriteLine("Change LongName: " + longName);
                }
            }
        }



        public long PIndex {
            get { return pindex; }
            set {
                if (value != pindex) {
                    NotifyPropertyChanged("PIndex");                    
                    modifyAttrib = true;
                    pindex = value;
                }
            }
        }


        public override bool Equals(object obj) {
            if (obj is ModelDept) {
                ModelDept dept = (ModelDept)obj;
                return shortName.Equals(dept.shortName);
            }
            else {
                return false;
            }

        }

        public override int GetHashCode() {
            return shortName.GetHashCode();
        }


        public override String ToString() {
            return shortName;
        }




    }


}
