﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.ComponentModel;
using DB_ABT.Models;
using DB_ABT.Fenster;
using System.Collections.ObjectModel;

namespace DB_ABT.Models {
    public class ModelEmployee : ModelBase {

        public static ObservableCollection<ModelDept>
            dept_items = new ObservableCollection<ModelDept>();

        private long pindex;
        private String firstname;
        private String lastname;
        private double monthsalary;
        private double yearsalary;
        private long deptIindex;
        private ModelDept dept;

        public ModelEmployee():this(-1,"","",0,-1) {
        }

        public ModelEmployee(long pindex, String firstname, String lastname, double monthsalary, long aindex) {
            Firstname = firstname;
            Lastname = lastname;
            Monthsalary = monthsalary;
            DeptIindex = aindex;
        }

        public void setDept() {
            foreach (ModelDept dept_for in ModelEmployee.dept_items) {
                if (dept_for.PIndex == deptIindex) {
                    this.dept = new ModelDept(dept_for);
                    break;
                }
            }
        }


        public override int CompareTo(object obj) {
            ModelEmployee mit = (ModelEmployee)obj;
            int i = lastname.CompareTo(mit.lastname);
            if (i != 0)
                return i;
            else
                return firstname.CompareTo(mit.firstname);
        }

        public String getFirstnameQuote() {
            return "'" + firstname + "'";
        }
        public String getLastameQuote() {
            return "'" + lastname + "'";
        }


        public String Firstname {
            get { return firstname; }
            set {
                if (value != firstname) {
                    NotifyPropertyChanged("Firstname");
                    modifyAttrib = true;
                    firstname = value;
                    System.Diagnostics.Debug.WriteLine("Change Firstname: " + firstname);
                }
            }
        }

        public String getLastnameQuote() {
            return "'" + lastname + "'";
        }

        public String Lastname {
            get { return lastname; }
            set {
                if (value != lastname) {
                    NotifyPropertyChanged("Lastname");
                    modifyAttrib = true;
                    lastname = value;
                    System.Diagnostics.Debug.WriteLine("Change Lastname: " + lastname);
                }
            }
        }


        public double Monthsalary {
            get { return monthsalary; }
            set {
                if (value != monthsalary) {
                    NotifyPropertyChanged("Monthsalary");
                    modifyAttrib = true;
                    monthsalary = value;
                    Yearsalary = monthsalary * 12.0;
                    System.Diagnostics.Debug.WriteLine("Change Monthsalary: " + monthsalary);
                }
            }
        }


        // muss vorhanden sein, für die Datagrid
        public double Yearsalary {
            get { return yearsalary; }
            set {
                if (value != yearsalary) {
                    NotifyPropertyChanged("Yearsalary");
                    modifyAttrib = true;                    
                    yearsalary = value;
                    System.Diagnostics.Debug.WriteLine("Change Yearsalary: " + yearsalary);
                }
            }
        }

        public void updateYearsalary() {
            NotifyPropertyChanged("Yearsalary");
            System.Diagnostics.Debug.WriteLine("updateYearsalary: " + yearsalary);
        }


        public long PIndex {
            get { return pindex; }
            set {
                if (value != pindex) {
                    NotifyPropertyChanged("PIndex");
                    modifyAttrib = true;
                    pindex = value;
                }
            }
        }

        public ModelDept Dept {
            get { return dept; }
            set {
                NotifyPropertyChanged("Dept");
                modifyAttrib = true;
                dept = value;
                deptIindex = dept.PIndex;
            }
        }



        public long DeptIindex {
            get { return deptIindex; }
            set {
                if (value != deptIindex) {
                    NotifyPropertyChanged("AIndex");
                    modifyAttrib = true;
                    deptIindex = value;
                }
            }
        }




        public override String ToString() {
            return lastname + "   " + firstname;
        }




    }


}
