﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DB_ABT.UserControls {
    /// <summary>
    /// Interaktionslogik für Navigationbar.xaml
    /// </summary>
    public partial class Navigationbar : UserControl {

        private INavigatorbar databaseparent;
        private int nr;

        public Navigationbar() {
            InitializeComponent();
        }

        public void setDatabaseParent(INavigatorbar databaseparent, int nr) {
            this.databaseparent = databaseparent;
            this.nr = nr;
        }

        public void setPosition(long position) {
            tRow.Text = position.ToString();
        }

        public void setCount(int count) {
            lRow.Content = "von {" + count + "}";
        }

        private void bnFirst_Click(object sender, RoutedEventArgs e) {
            databaseparent.setFirst(nr);
        }

        private void bnPrev_Click(object sender, RoutedEventArgs e) {
            databaseparent.setPrev(nr);
        }

        private void bnNext_Click(object sender, RoutedEventArgs e) {
            databaseparent.setNext(nr);
        }

        private void bnLast_Click(object sender, RoutedEventArgs e) {
            databaseparent.setLast(nr);
        }

        private void bnPlus_Click(object sender, RoutedEventArgs e) {
            databaseparent.setInsert(nr);
        }
        private void bnDelete_Click(object sender, RoutedEventArgs e) {
            databaseparent.setDelete(nr);
        }

        private void bnCancel_Click(object sender, RoutedEventArgs e) {
            databaseparent.setCancel(nr);
        }

        private void tFilter_TextChanged(object sender, TextChangedEventArgs e) {
            databaseparent.setFilter(nr,tFilter.Text.Trim());
        }

        public void setRow(int row) {
            tRow.Text = row.ToString();
        }



    }
}
